﻿// 指定した輝度にする。色相や彩度はそのまま
(function(){
    var defB = prompt("輝度を入れて下さい(0〜100)", 50);
    if (!defB){ return; }
    defB = parseFloat(defB)/100;
    // 選択処理
    var selObj = app.activeDocument.selection;
    for(var i=0; i<selObj.length; i++){
        RGBcolor = selObj[i].fillColor;
        var R = RGBcolor.red;
        var G = RGBcolor.green;
        var B = RGBcolor.blue;
        //$.writeln("RGB = "+R+","+G+","+B);
        var HSB = RGBtoHSB(R, G, B);
        var H = HSB.H;
        var S = HSB.S;
        var B = HSB.B;  // 色相（今回は使っていない）
        //$.writeln("HSB : "+H+", "+S+", "+B);
        var tempRGB = HSBtoRGB(H, S, defB);
        var myRGB = new RGBColor();
        //$.writeln("temp:"+tempRGB.R+", "+tempRGB.G+", "+tempRGB.B);
        myRGB.red = Math.floor(tempRGB.R*255);
        myRGB.green = Math.floor(tempRGB.G*255);
        myRGB.blue = Math.floor(tempRGB.B*255);
        //$.writeln(myRGB.red+", "+myRGB.green+", "+myRGB.blue);
        selObj[i].fillColor = myRGB;
    }
})();
// RGBからHSB (R:0~255, G:0〜255, B:0〜255, h:0〜360, s:0〜1, B:0〜1)
function RGBtoHSB(r, g, b){
	var h = s = v = 0;
	if ( r >= g)   cmax = r; else cmax = g;
	if ( b > cmax) cmax = b;
	if ( r <= g)   cmin = r; else cmin = g;
	if ( b < cmin) cmin = b;
	v = cmax;
	var c = cmax - cmin;
	if (cmax == 0) s = 0; else s = c/cmax;
	if (s != 0){
		if (r == cmax){ h = (g - b)/c;
		}else{
			if (g == cmax){ h = 2 + (b - r)/c;
			}else{
				if (b == cmax) h = 4 + ( r - g)/c;
			}
		}
		h = h * 60;
		if (h < 0) h = h + 360;
	}
	return { H:h, S:s, B:v/255 }
}
// HSBからRGB (R:0~1, G:0〜1, B:0〜1, h:0〜360, s:0〜1, B:0〜1)
function HSBtoRGB(h, s, v){
    var r = g = b = 0;
	if (s < 0) s = 0;
	if (s > 1) s = 1;
	if (v < 0) v = 0;
	if (v > 1) v = 1;
	h = h % 360;
	if (h < 0) h = h + 360;
	h = h / 60;
	i = Math.floor(h);
	var f = h - i;
	p1 = v * (1 - s);
	p2 = v * (1 - s*f);
	p3 = v * (1 - s*(1 - f));
	if (i == 0) { r = v; g = p3; b = p1; }
	if (i == 1) { r = p2;g = v;  b = p1; }
	if (i == 2) { r = p1;g = v;  b = p3; }
	if (i == 3) { r = p1;g = p2; b = v;  }
	if (i == 4) { r = p3;g = p1; b = v;  }
	if (i == 5) { r = v; g = p1; b = p2; }
	return { R:r, G:g, B:b }
}
